Top and Bottom Markets in JavaScript

Using ApexCharts with JavaScript

This Top and Bottom Markets example uses ApexCharts.js directly in JavaScript, with no wrapper component.

Install it with npm install apexcharts, then mount the chart with new ApexCharts(element, options).render().

JavaScript installation guide
// Forty-two markets, three years of monthly activation rate, no axes at all.
// At this size an axis costs more than it pays: the shared scale is stated
// once in the caption, each panel labels its own latest value, and the ink
// left over is the trend. The five best and five weakest latest rates are
// tinted so the extremes are findable without reading 42 numbers.
//
// Deterministic series so the e2e snapshot is stable.
function mulberry32(seed) {
  return function () {
    seed |= 0
    seed = (seed + 0x6d2b79f5) | 0
    var t = Math.imul(seed ^ (seed >>> 15), 1 | seed)
    t = (t + Math.imul(t ^ (t >>> 7), 61 | t)) ^ t
    return ((t ^ (t >>> 14)) >>> 0) / 4294967296
  }
}

var MARKETS = [
  'Amsterdam',
  'Antwerp',
  'Athens',
  'Auckland',
  'Austin',
  'Bergen',
  'Bilbao',
  'Bologna',
  'Bristol',
  'Calgary',
  'Cardiff',
  'Cork',
  'Dublin',
  'Dundee',
  'Edinburgh',
  'Galway',
  'Ghent',
  'Graz',
  'Helsinki',
  'Kingston',
  'Leeds',
  'Leiden',
  'Lisbon',
  'Lyon',
  'Malaga',
  'Malmo',
  'Nantes',
  'Oporto',
  'Oslo',
  'Ottawa',
  'Padua',
  'Perth',
  'Reykjavik',
  'Rotterdam',
  'Salerno',
  'Seville',
  'Tampere',
  'Turin',
  'Turku',
  'Utrecht',
  'Verona',
  'Zurich',
]

var MONTHS = 36
var START = new Date(2023, 0, 1).getTime()
var MONTH_MS = 30.44 * 24 * 3600 * 1000

// A trend plus a wobble, so the panels have shape rather than noise.
function activationSeries(seed, start, drift) {
  var rand = mulberry32(seed)
  var out = []
  var v = start
  for (var m = 0; m < MONTHS; m++) {
    v += drift + (rand() - 0.5) * 0.55
    // A mild seasonal lift in the second half of each year.
    var season = Math.sin(((m % 12) / 12) * Math.PI * 2) * 0.28
    out.push({
      x: Math.round(START + m * MONTH_MS),
      y: Math.max(1.2, Math.round((v + season) * 100) / 100),
    })
  }
  return out
}

var marketSeries = MARKETS.map(function (name, i) {
  var rand = mulberry32(1000 + i * 13)
  var start = 2.4 + rand() * 3.2
  var drift = (rand() - 0.42) * 0.11
  return {
    name: 'Activation rate',
    market: name,
    data: activationSeries(200 + i * 7, start, drift),
  }
})

// Rank on the LATEST value: the five best get the teal tint, the five
// weakest the amber one, everything else stays quiet grey.
var latest = {}
marketSeries.forEach(function (s) {
  latest[s.market] = s.data[s.data.length - 1].y
})
var ranked = MARKETS.slice().sort(function (a, b) {
  return latest[b] - latest[a]
})
var TOP = {}
var BOTTOM = {}
ranked.slice(0, 5).forEach(function (m) {
  TOP[m] = true
})
ranked.slice(-5).forEach(function (m) {
  BOTTOM[m] = true
})

var options = {
  series: marketSeries,
  chart: {
    id: 'marketTrellis',
    type: 'line',
    height: 700,
    animations: {
      enabled: false,
    },
  },
  trellis: {
    by: 'market',
    columns: 7,
    minPanelWidth: 130,
    panelHeight: 76,
    gap: 6,
    header: {
      style: {
        fontSize: '11px',
        fontWeight: 600,
      },
    },
    panel: function (key) {
      // The value label rides the last point, so which SIDE of it has room
      // depends on where that point sits in the shared 0-10 frame: below for a
      // high panel, above for a low one. `panel()` is merged last, so the
      // per-panel offset is a two-line override.
      var side = { dataLabels: { offsetY: latest[key] > 5 ? 15 : -8 } }
      if (TOP[key]) {
        return Object.assign(
          { colors: ['#0F766E'], chart: { background: '#EAF4F2' } },
          side,
        )
      }
      if (BOTTOM[key]) {
        return Object.assign(
          { colors: ['#B45309'], chart: { background: '#FBF1E3' } },
          side,
        )
      }
      return Object.assign({ colors: ['#94A3B8'] }, side)
    },
  },
  stroke: {
    width: 1.5,
    curve: 'straight',
  },
  markers: {
    size: 0,
    discrete: [
      {
        seriesIndex: 0,
        dataPointIndex: 35,
        size: 3,
        strokeWidth: 0,
      },
    ],
  },
  dataLabels: {
    enabled: true,
    offsetX: -10,
    offsetY: -8,
    background: {
      enabled: false,
    },
    style: {
      fontSize: '10px',
      fontWeight: 600,
      colors: ['#475569'],
    },
    formatter: function (val, opts) {
      var d = opts.w.config.series[opts.seriesIndex].data
      return opts.dataPointIndex === d.length - 1 ? Number(val).toFixed(1) : ''
    },
  },
  yaxis: {
    labels: {
      show: false,
    },
  },
  xaxis: {
    type: 'datetime',
    labels: {
      show: false,
    },
    axisTicks: {
      show: false,
    },
    axisBorder: {
      show: false,
    },
    tooltip: {
      enabled: false,
    },
  },
  grid: {
    show: false,
    padding: {
      left: 4,
      right: 4,
    },
  },
  tooltip: {
    x: {
      format: 'MMM yyyy',
    },
  },
}

var chart = new ApexCharts(document.querySelector('#chart'), options)
chart.render()

Top and Bottom Markets in React

Using ApexCharts with React

This Top and Bottom Markets example wires ApexCharts into React through the react-apexcharts component.

Install it with npm install react-apexcharts apexcharts, then mount the chart with <Chart type="..." options={options} series={series} />.

React charts guide
import React from 'react'
import ReactApexChart from 'react-apexcharts'
import './styles.css'

import 'apexcharts/features/trellis'

// Forty-two markets, three years of monthly activation rate, no axes at all.
// At this size an axis costs more than it pays: the shared scale is stated
// once in the caption, each panel labels its own latest value, and the ink
// left over is the trend. The five best and five weakest latest rates are
// tinted so the extremes are findable without reading 42 numbers.
//
// Deterministic series so the e2e snapshot is stable.
function mulberry32(seed) {
  return function () {
    seed |= 0
    seed = (seed + 0x6d2b79f5) | 0
    var t = Math.imul(seed ^ (seed >>> 15), 1 | seed)
    t = (t + Math.imul(t ^ (t >>> 7), 61 | t)) ^ t
    return ((t ^ (t >>> 14)) >>> 0) / 4294967296
  }
}

var MARKETS = [
  'Amsterdam',
  'Antwerp',
  'Athens',
  'Auckland',
  'Austin',
  'Bergen',
  'Bilbao',
  'Bologna',
  'Bristol',
  'Calgary',
  'Cardiff',
  'Cork',
  'Dublin',
  'Dundee',
  'Edinburgh',
  'Galway',
  'Ghent',
  'Graz',
  'Helsinki',
  'Kingston',
  'Leeds',
  'Leiden',
  'Lisbon',
  'Lyon',
  'Malaga',
  'Malmo',
  'Nantes',
  'Oporto',
  'Oslo',
  'Ottawa',
  'Padua',
  'Perth',
  'Reykjavik',
  'Rotterdam',
  'Salerno',
  'Seville',
  'Tampere',
  'Turin',
  'Turku',
  'Utrecht',
  'Verona',
  'Zurich',
]

var MONTHS = 36
var START = new Date(2023, 0, 1).getTime()
var MONTH_MS = 30.44 * 24 * 3600 * 1000

// A trend plus a wobble, so the panels have shape rather than noise.
function activationSeries(seed, start, drift) {
  var rand = mulberry32(seed)
  var out = []
  var v = start
  for (var m = 0; m < MONTHS; m++) {
    v += drift + (rand() - 0.5) * 0.55
    // A mild seasonal lift in the second half of each year.
    var season = Math.sin(((m % 12) / 12) * Math.PI * 2) * 0.28
    out.push({
      x: Math.round(START + m * MONTH_MS),
      y: Math.max(1.2, Math.round((v + season) * 100) / 100),
    })
  }
  return out
}

var marketSeries = MARKETS.map(function (name, i) {
  var rand = mulberry32(1000 + i * 13)
  var start = 2.4 + rand() * 3.2
  var drift = (rand() - 0.42) * 0.11
  return {
    name: 'Activation rate',
    market: name,
    data: activationSeries(200 + i * 7, start, drift),
  }
})

// Rank on the LATEST value: the five best get the teal tint, the five
// weakest the amber one, everything else stays quiet grey.
var latest = {}
marketSeries.forEach(function (s) {
  latest[s.market] = s.data[s.data.length - 1].y
})
var ranked = MARKETS.slice().sort(function (a, b) {
  return latest[b] - latest[a]
})
var TOP = {}
var BOTTOM = {}
ranked.slice(0, 5).forEach(function (m) {
  TOP[m] = true
})
ranked.slice(-5).forEach(function (m) {
  BOTTOM[m] = true
})

const ApexChart = () => {
  const [state, setState] = React.useState({
    series: marketSeries,
    options: {
      chart: {
        id: 'marketTrellis',
        type: 'line',
        height: 700,
        animations: {
          enabled: false,
        },
      },
      trellis: {
        by: 'market',
        columns: 7,
        minPanelWidth: 130,
        panelHeight: 76,
        gap: 6,
        header: {
          style: {
            fontSize: '11px',
            fontWeight: 600,
          },
        },
        panel: function (key) {
          // The value label rides the last point, so which SIDE of it has room
          // depends on where that point sits in the shared 0-10 frame: below for a
          // high panel, above for a low one. `panel()` is merged last, so the
          // per-panel offset is a two-line override.
          var side = { dataLabels: { offsetY: latest[key] > 5 ? 15 : -8 } }
          if (TOP[key]) {
            return Object.assign(
              { colors: ['#0F766E'], chart: { background: '#EAF4F2' } },
              side,
            )
          }
          if (BOTTOM[key]) {
            return Object.assign(
              { colors: ['#B45309'], chart: { background: '#FBF1E3' } },
              side,
            )
          }
          return Object.assign({ colors: ['#94A3B8'] }, side)
        },
      },
      stroke: {
        width: 1.5,
        curve: 'straight',
      },
      markers: {
        size: 0,
        discrete: [
          {
            seriesIndex: 0,
            dataPointIndex: 35,
            size: 3,
            strokeWidth: 0,
          },
        ],
      },
      dataLabels: {
        enabled: true,
        offsetX: -10,
        offsetY: -8,
        background: {
          enabled: false,
        },
        style: {
          fontSize: '10px',
          fontWeight: 600,
          colors: ['#475569'],
        },
        formatter: function (val, opts) {
          var d = opts.w.config.series[opts.seriesIndex].data
          return opts.dataPointIndex === d.length - 1
            ? Number(val).toFixed(1)
            : ''
        },
      },
      yaxis: {
        labels: {
          show: false,
        },
      },
      xaxis: {
        type: 'datetime',
        labels: {
          show: false,
        },
        axisTicks: {
          show: false,
        },
        axisBorder: {
          show: false,
        },
        tooltip: {
          enabled: false,
        },
      },
      grid: {
        show: false,
        padding: {
          left: 4,
          right: 4,
        },
      },
      tooltip: {
        x: {
          format: 'MMM yyyy',
        },
      },
    },
  })

  return (
    <div>
      <div className="wrap">
        <h1>Activation rate by market, 2023 to 2025</h1>
        <p className="lead">
          Forty-two panels, no axes, one shared scale stated once. Every panel
          labels its own latest value, so the grid stays readable at 42 markets
          where a 42-series line chart is a hairball and a 42-row table is
          homework.
        </p>
        <p className="key">
          <span className="up">Top 5</span> vs{' '}
          <span className="down">Bottom 5</span>
          <span className="rest">
            by latest rate, all panels on a shared 0-10% scale
          </span>
        </p>

        <div className="chart-wrap">
          <div id="chart">
            <ReactApexChart
              options={state.options}
              series={state.series}
              type="line"
              height={700}
            />
          </div>
        </div>

        <div className="note">
          Dropping the axes is the user's own options, not a trellis mode: turn
          the labels, ticks, borders and gridlines off and every panel loses the
          same space, so the panels stay pixel-aligned. The conditional tint
          comes from
          <code>trellis.panel</code>, which is merged last and can therefore
          override anything, here a <code>chart.background</code> and a stroke
          colour per panel. Every cell also carries its facet key as
          <code>data-key</code>, so plain CSS can style the panel chrome (the
          header, the border) the same way. Hovering gives a one-line tooltip
          rather than a card: panels this short get <code>tooltip.compact</code>
          automatically (set it yourself, either way, and the trellis leaves the
          decision alone). Trellis is a premium feature; without a license it
          renders with a trial watermark.
        </div>
      </div>
    </div>
  )
}

export default ApexChart

Top and Bottom Markets in Vue

Using ApexCharts with Vue

This Top and Bottom Markets example wires ApexCharts into Vue through the vue3-apexcharts component.

Install it with npm install vue3-apexcharts apexcharts, then mount the chart with <apexchart type="..." :options="options" :series="series" />.

Vue charts guide
<template>
  <div>
    <div class="wrap">
      <h1>Activation rate by market, 2023 to 2025</h1>
      <p class="lead">
        Forty-two panels, no axes, one shared scale stated once. Every panel
        labels its own latest value, so the grid stays readable at 42 markets
        where a 42-series line chart is a hairball and a 42-row table is
        homework.
      </p>
      <p class="key">
        <span class="up">Top 5</span> vs <span class="down">Bottom 5</span>
        <span class="rest"
          >by latest rate, all panels on a shared 0-10% scale</span
        >
      </p>

      <div class="chart-wrap">
        <div id="chart">
          <apexchart
            type="line"
            height="700"
            :options="chartOptions"
            :series="series"
          ></apexchart>
        </div>
      </div>

      <div class="note">
        Dropping the axes is the user's own options, not a trellis mode: turn
        the labels, ticks, borders and gridlines off and every panel loses the
        same space, so the panels stay pixel-aligned. The conditional tint comes
        from
        <code>trellis.panel</code>, which is merged last and can therefore
        override anything, here a <code>chart.background</code> and a stroke
        colour per panel. Every cell also carries its facet key as
        <code>data-key</code>, so plain CSS can style the panel chrome (the
        header, the border) the same way. Hovering gives a one-line tooltip
        rather than a card: panels this short get <code>tooltip.compact</code>
        automatically (set it yourself, either way, and the trellis leaves the
        decision alone). Trellis is a premium feature; without a license it
        renders with a trial watermark.
      </div>
    </div>
  </div>
</template>

<script>
import VueApexCharts from 'vue-apexcharts'

import 'apexcharts/features/trellis'

// Forty-two markets, three years of monthly activation rate, no axes at all.
// At this size an axis costs more than it pays: the shared scale is stated
// once in the caption, each panel labels its own latest value, and the ink
// left over is the trend. The five best and five weakest latest rates are
// tinted so the extremes are findable without reading 42 numbers.
//
// Deterministic series so the e2e snapshot is stable.
function mulberry32(seed) {
  return function () {
    seed |= 0
    seed = (seed + 0x6d2b79f5) | 0
    var t = Math.imul(seed ^ (seed >>> 15), 1 | seed)
    t = (t + Math.imul(t ^ (t >>> 7), 61 | t)) ^ t
    return ((t ^ (t >>> 14)) >>> 0) / 4294967296
  }
}

var MARKETS = [
  'Amsterdam',
  'Antwerp',
  'Athens',
  'Auckland',
  'Austin',
  'Bergen',
  'Bilbao',
  'Bologna',
  'Bristol',
  'Calgary',
  'Cardiff',
  'Cork',
  'Dublin',
  'Dundee',
  'Edinburgh',
  'Galway',
  'Ghent',
  'Graz',
  'Helsinki',
  'Kingston',
  'Leeds',
  'Leiden',
  'Lisbon',
  'Lyon',
  'Malaga',
  'Malmo',
  'Nantes',
  'Oporto',
  'Oslo',
  'Ottawa',
  'Padua',
  'Perth',
  'Reykjavik',
  'Rotterdam',
  'Salerno',
  'Seville',
  'Tampere',
  'Turin',
  'Turku',
  'Utrecht',
  'Verona',
  'Zurich',
]

var MONTHS = 36
var START = new Date(2023, 0, 1).getTime()
var MONTH_MS = 30.44 * 24 * 3600 * 1000

// A trend plus a wobble, so the panels have shape rather than noise.
function activationSeries(seed, start, drift) {
  var rand = mulberry32(seed)
  var out = []
  var v = start
  for (var m = 0; m < MONTHS; m++) {
    v += drift + (rand() - 0.5) * 0.55
    // A mild seasonal lift in the second half of each year.
    var season = Math.sin(((m % 12) / 12) * Math.PI * 2) * 0.28
    out.push({
      x: Math.round(START + m * MONTH_MS),
      y: Math.max(1.2, Math.round((v + season) * 100) / 100),
    })
  }
  return out
}

var marketSeries = MARKETS.map(function (name, i) {
  var rand = mulberry32(1000 + i * 13)
  var start = 2.4 + rand() * 3.2
  var drift = (rand() - 0.42) * 0.11
  return {
    name: 'Activation rate',
    market: name,
    data: activationSeries(200 + i * 7, start, drift),
  }
})

// Rank on the LATEST value: the five best get the teal tint, the five
// weakest the amber one, everything else stays quiet grey.
var latest = {}
marketSeries.forEach(function (s) {
  latest[s.market] = s.data[s.data.length - 1].y
})
var ranked = MARKETS.slice().sort(function (a, b) {
  return latest[b] - latest[a]
})
var TOP = {}
var BOTTOM = {}
ranked.slice(0, 5).forEach(function (m) {
  TOP[m] = true
})
ranked.slice(-5).forEach(function (m) {
  BOTTOM[m] = true
})

export default {
  components: {
    apexchart: VueApexCharts,
  },
  data: function () {
    return {
      series: marketSeries,
      chartOptions: {
        chart: {
          id: 'marketTrellis',
          type: 'line',
          height: 700,
          animations: {
            enabled: false,
          },
        },
        trellis: {
          by: 'market',
          columns: 7,
          minPanelWidth: 130,
          panelHeight: 76,
          gap: 6,
          header: {
            style: {
              fontSize: '11px',
              fontWeight: 600,
            },
          },
          panel: function (key) {
            // The value label rides the last point, so which SIDE of it has room
            // depends on where that point sits in the shared 0-10 frame: below for a
            // high panel, above for a low one. `panel()` is merged last, so the
            // per-panel offset is a two-line override.
            var side = { dataLabels: { offsetY: latest[key] > 5 ? 15 : -8 } }
            if (TOP[key]) {
              return Object.assign(
                { colors: ['#0F766E'], chart: { background: '#EAF4F2' } },
                side,
              )
            }
            if (BOTTOM[key]) {
              return Object.assign(
                { colors: ['#B45309'], chart: { background: '#FBF1E3' } },
                side,
              )
            }
            return Object.assign({ colors: ['#94A3B8'] }, side)
          },
        },
        stroke: {
          width: 1.5,
          curve: 'straight',
        },
        markers: {
          size: 0,
          discrete: [
            {
              seriesIndex: 0,
              dataPointIndex: 35,
              size: 3,
              strokeWidth: 0,
            },
          ],
        },
        dataLabels: {
          enabled: true,
          offsetX: -10,
          offsetY: -8,
          background: {
            enabled: false,
          },
          style: {
            fontSize: '10px',
            fontWeight: 600,
            colors: ['#475569'],
          },
          formatter: function (val, opts) {
            var d = opts.w.config.series[opts.seriesIndex].data
            return opts.dataPointIndex === d.length - 1
              ? Number(val).toFixed(1)
              : ''
          },
        },
        yaxis: {
          labels: {
            show: false,
          },
        },
        xaxis: {
          type: 'datetime',
          labels: {
            show: false,
          },
          axisTicks: {
            show: false,
          },
          axisBorder: {
            show: false,
          },
          tooltip: {
            enabled: false,
          },
        },
        grid: {
          show: false,
          padding: {
            left: 4,
            right: 4,
          },
        },
        tooltip: {
          x: {
            format: 'MMM yyyy',
          },
        },
      },
    }
  },
}
</script>

<style>
body {
  font-family:
    -apple-system, BlinkMacSystemFont, 'Segoe UI', Roboto, sans-serif;
  background: #fafbfc;
  color: #2c3e50;
  margin: 0;
  padding: 32px 16px;
}
.wrap {
  max-width: 1160px;
  margin: 0 auto;
}
h1 {
  font-size: 22px;
  margin: 0 0 8px;
}
.lead {
  color: #5b6b78;
  line-height: 1.5;
  margin: 0 0 14px;
}
.key {
  font-size: 14px;
  font-weight: 600;
  margin: 0 0 18px;
}
.key .up {
  color: #0f766e;
}
.key .down {
  color: #b45309;
}
.key .rest {
  color: #94a3b8;
  font-weight: 400;
}
.chart-wrap {
  background: #fff;
  border-radius: 8px;
  padding: 14px;
  box-shadow: 0 2px 10px rgba(0, 0, 0, 0.04);
}
.note {
  background: #f0fdf4;
  border-left: 3px solid #15803d;
  padding: 12px 16px;
  font-size: 13px;
  color: #333;
  border-radius: 2px;
  line-height: 1.6;
  margin: 26px auto 0;
}
.note code {
  background: #dcfce7;
  padding: 1px 5px;
  border-radius: 3px;
}
</style>

Top and Bottom Markets in Angular

Using ApexCharts with Angular

This Top and Bottom Markets example wires ApexCharts into Angular through the ng-apexcharts component.

Install it with npm install ng-apexcharts apexcharts, then mount the chart with <apx-chart [series]="series" [chart]="chart"></apx-chart>.

Angular charts guide

This demo uses imperative chart updates. The generated code is a faithful Angular translation: open it in CodeSandbox to run and tweak.

import { Component, AfterViewInit, OnDestroy, ViewChild } from '@angular/core';
import {
  ChartComponent,
  ApexAxisChartSeries,
  ApexNonAxisChartSeries,
  ApexChart,
  ApexXAxis,
  ApexYAxis,
  ApexTitleSubtitle,
  ApexDataLabels,
  ApexStroke,
  ApexFill,
  ApexLegend,
  ApexTooltip,
  ApexMarkers,
  ApexPlotOptions,
  ApexResponsive,
  ApexGrid,
  ApexAnnotations,
  ApexStates,
  ApexTheme,
  NgApexchartsModule,
} from 'ng-apexcharts';

export type ChartOptions = {
  series?: ApexAxisChartSeries | ApexNonAxisChartSeries;
  chart?: ApexChart;
  xaxis?: ApexXAxis;
  yaxis?: ApexYAxis | ApexYAxis[];
  title?: ApexTitleSubtitle;
  subtitle?: ApexTitleSubtitle;
  dataLabels?: ApexDataLabels;
  stroke?: ApexStroke;
  fill?: ApexFill;
  legend?: ApexLegend;
  tooltip?: ApexTooltip;
  markers?: ApexMarkers;
  plotOptions?: ApexPlotOptions;
  responsive?: ApexResponsive[];
  grid?: ApexGrid;
  annotations?: ApexAnnotations;
  states?: ApexStates;
  theme?: ApexTheme;
  colors?: string[];
  labels?: any;
};

@Component({
  selector: 'app-chart',
  standalone: true,
  imports: [NgApexchartsModule],
  templateUrl: './chart.component.html',
})
export class AppChart implements AfterViewInit, OnDestroy {
  @ViewChild('chart') chart!: ChartComponent;
  private mulberry32 = (seed: any): any => {
        return function () {
          seed |= 0
          seed = (seed + 0x6d2b79f5) | 0
          var t = Math.imul(seed ^ (seed >>> 15), 1 | seed)
          t = (t + Math.imul(t ^ (t >>> 7), 61 | t)) ^ t
          return ((t ^ (t >>> 14)) >>> 0) / 4294967296
        }
      };

  private MARKETS: any = [
        'Amsterdam',
        'Antwerp',
        'Athens',
        'Auckland',
        'Austin',
        'Bergen',
        'Bilbao',
        'Bologna',
        'Bristol',
        'Calgary',
        'Cardiff',
        'Cork',
        'Dublin',
        'Dundee',
        'Edinburgh',
        'Galway',
        'Ghent',
        'Graz',
        'Helsinki',
        'Kingston',
        'Leeds',
        'Leiden',
        'Lisbon',
        'Lyon',
        'Malaga',
        'Malmo',
        'Nantes',
        'Oporto',
        'Oslo',
        'Ottawa',
        'Padua',
        'Perth',
        'Reykjavik',
        'Rotterdam',
        'Salerno',
        'Seville',
        'Tampere',
        'Turin',
        'Turku',
        'Utrecht',
        'Verona',
        'Zurich',
      ];

  private MONTHS: any = 36;

  private START: any = new Date(2023, 0, 1).getTime();

  private MONTH_MS: any = 30.44 * 24 * 3600 * 1000;

  private activationSeries = (seed: any, start: any, drift: any): any => {
        var rand = this.mulberry32(seed)
        var out = []
        var v = start
        for (var m = 0; m < this.MONTHS; m++) {
          v += drift + (rand() - 0.5) * 0.55
          // A mild seasonal lift in the second half of each year.
          var season = Math.sin(((m % 12) / 12) * Math.PI * 2) * 0.28
          out.push({
            x: Math.round(this.START + m * this.MONTH_MS),
            y: Math.max(1.2, Math.round((v + season) * 100) / 100),
          })
        }
        return out
      };

  private marketSeries: any = this.MARKETS.map(function (name, i) {
        var rand = this.mulberry32(1000 + i * 13)
        var start = 2.4 + rand() * 3.2
        var drift = (rand() - 0.42) * 0.11
        return {
          name: 'Activation rate',
          market: name,
          data: this.activationSeries(200 + i * 7, start, drift),
        }
      });

  private latest: any = {};

  private ranked: any = this.MARKETS.slice().sort(function (a, b) {
        return this.latest[b] - this.latest[a]
      });

  private TOP: any = {};

  private BOTTOM: any = {};

  public chartOptions: Partial<ChartOptions> = {
          series: this.marketSeries,
          chart: {
            id: 'marketTrellis',
            type: 'line',
            height: 700,
            animations: {
              enabled: false,
            },
          },
          trellis: {
            by: 'market',
            columns: 7,
            minPanelWidth: 130,
            panelHeight: 76,
            gap: 6,
            header: {
              style: {
                fontSize: '11px',
                fontWeight: 600,
              },
            },
            panel: (key) => {
              // The value label rides the last point, so which SIDE of it has room
              // depends on where that point sits in the shared 0-10 frame: below for a
              // high panel, above for a low one. `panel()` is merged last, so the
              // per-panel offset is a two-line override.
              var side = { dataLabels: { offsetY: this.latest[key] > 5 ? 15 : -8 } }
              if (this.TOP[key]) {
                return Object.assign(
                  { colors: ['#0F766E'], chart: { background: '#EAF4F2' } },
                  side,
                )
              }
              if (this.BOTTOM[key]) {
                return Object.assign(
                  { colors: ['#B45309'], chart: { background: '#FBF1E3' } },
                  side,
                )
              }
              return Object.assign({ colors: ['#94A3B8'] }, side)
            },
          },
          stroke: {
            width: 1.5,
            curve: 'straight',
          },
          markers: {
            size: 0,
            discrete: [
              {
                seriesIndex: 0,
                dataPointIndex: 35,
                size: 3,
                strokeWidth: 0,
              },
            ],
          },
          dataLabels: {
            enabled: true,
            offsetX: -10,
            offsetY: -8,
            background: {
              enabled: false,
            },
            style: {
              fontSize: '10px',
              fontWeight: 600,
              colors: ['#475569'],
            },
            formatter: (val, opts) => {
              var d = opts.w.config.series[opts.seriesIndex].data
              return opts.dataPointIndex === d.length - 1 ? Number(val).toFixed(1) : ''
            },
          },
          yaxis: {
            labels: {
              show: false,
            },
          },
          xaxis: {
            type: 'datetime',
            labels: {
              show: false,
            },
            axisTicks: {
              show: false,
            },
            axisBorder: {
              show: false,
            },
            tooltip: {
              enabled: false,
            },
          },
          grid: {
            show: false,
            padding: {
              left: 4,
              right: 4,
            },
          },
          tooltip: {
            x: {
              format: 'MMM yyyy',
            },
          },
        };
  ngAfterViewInit() {
    (window as any).ApexCharts.setLicense('APEX-eyJleHBpcnlEYXRlIjoiMjEyNi0wNy0wNCIsImlzc3VlRGF0ZSI6IjIwMjYtMDctMjgiLCJwbGFuIjoicHJlbWl1bSIsImRvbWFpbnMiOlsiYXBleGNoYXJ0cy5jb20iLCIxMjcuMC4wLjEiLCJsb2NhbGhvc3QiXSwic2lnIjoieVBmb1VCc0Z3TU9ZdUEyaEZkR0I2Y1FtZ0JITUtXcVdJSjB2NVRESXRZbFR3eDJMUmh6R2x0RUc3VXJ4X0s3b25ZMWRZb2Z2VGItN01ydFYyNDVyOWcifQ==');
    this.marketSeries.forEach(function (s) {
          this.latest[s.market] = s.data[s.data.length - 1].y
        })
    this.ranked.slice(0, 5).forEach(function (m) {
          this.TOP[m] = true
        })
    this.ranked.slice(-5).forEach(function (m) {
          this.BOTTOM[m] = true
        })
  }

  ngOnDestroy() {
    // no cleanup needed
  }
}